/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20160108-64
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt4.dat, Fri Nov  4 02:20:03 2016
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000047F (1151)
 *     Revision         0x01
 *     Checksum         0xB2
 *     OEM ID           "LENOVO"
 *     OEM Table ID     "IsctTabl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120711 (538052369)
 */
DefinitionBlock ("ssdt4.aml", "SSDT", 1, "LENOVO", "IsctTabl", 0x00001000)
{
    /*
     * iASL Warning: There were 2 external control methods found during
     * disassembly, but additional ACPI tables to resolve these externals
     * were not specified. This resulting disassembler output file may not
     * compile because the disassembler did not know how many arguments
     * to assign to these methods. To specify the tables needed to resolve
     * external control method references, the -e option can be used to
     * specify the filenames. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (IFRS, MethodObj)    // Warning: Unresolved method, guessing 6 arguments
    External (SITT, MethodObj)    // Warning: Unresolved method, guessing 1 arguments

    External (_SB_.LID_._LID, IntObj)
    External (_SB_.PCI0.LPC_.EC__.GSTS, IntObj)
    External (_SB_.PCI0.LPC_.EC__.SKEM, UnknownObj)
    External (_SB_.PCI0.VID_.ASLC, UnknownObj)
    External (_SB_.PCI0.VID_.ASLE, UnknownObj)
    External (_SB_.PCI0.VID_.PARD, UnknownObj)
    External (_SB_.PCI0.VID_.STAT, UnknownObj)
    External (_SB_.PCI0.VID_.TCHE, UnknownObj)
    External (ISCG, UnknownObj)
    External (ISCT, IntObj)
    External (SLDR, UnknownObj)
    External (VIGD, IntObj)
    External (WAKR, IntObj)

    Scope (\_SB)
    {
        OperationRegion (SPRT, SystemIO, 0xB2, 0x02)
        Field (SPRT, ByteAcc, Lock, Preserve)
        {
            SSMP,   8
        }

        Device (IAOE)
        {
            Name (_HID, "INT33A0" /* Intel Smart Connect Technology Device */)  // _HID: Hardware ID
            Name (_UID, Zero)  // _UID: Unique ID
            Name (ABT0, Zero)
            Name (ABT1, Zero)
            Name (ANSB, Zero)
            Name (AWS1, Zero)
            Name (PTML, 0x23)
            Name (BLBD, 0x1E)
            Name (AWDT, 0x2D)
            Name (S0HL, 0xA5)
            Name (S0RL, 0x2D)
            Name (WKEC, Zero)
            Name (FFST, Zero)
            Method (GABS, 0, NotSerialized)
            {
                Return (ISCT) /* External reference */
            }

            Method (GAOS, 0, NotSerialized)
            {
                Local0 = ABT0 /* \_SB_.IAOE.ABT0 */
                Return ((Local0 & 0x03))
            }

            Method (SAOS, 1, NotSerialized)
            {
                If ((Arg0 & One))
                {
                    \IFRS (One, Local1, Else
                            {
                                \SITT (Zero)
                                Store (\IFRS (Zero, Zero, Local1, If (((Local1 & 0x00FFFF00) == 0x00FFFF00))
                                        {
                                            Local1 &= One
                                            If (FFST)
                                            {
                                                Local1 |= FFST /* \_SB_.IAOE.FFST */
                                                FFST = Zero
                                            }

                                            \IFRS (One, Local1, If (\VIGD)
                                                {
                                                    If ((\_SB.PCI0.VID.TCHE & 0x0100))
                                                    {
                                                        If (!\_SB.PCI0.VID.PARD)
                                                        {
                                                            \_SB.PCI0.VID.STAT = (\_SB.PCI0.VID.STAT & 0xFFFFFFFC)
                                                            \_SB.PCI0.VID.ASLC = (\_SB.PCI0.VID.ASLC | 0x0100)
                                                            \_SB.PCI0.VID.ASLE = One
                                                        }
                                                    }
                                                }, \_SB.PCI0.LPC.EC.SKEM = Zero, ABT0 = (Arg0 & 0x03))
                                        })
                            }) = 
                                                                \IFRS (Zero, Zero, Local1, FFST = (Local1 & 0x00FFFF00), Local1 &= One, Local1 |= 
                                                                0x00FFFF00)
                }
            }

            Method (GANS, 0, NotSerialized)
            {
                Return (ANSB) /* \_SB_.IAOE.ANSB */
            }

            Method (SANS, 1, NotSerialized)
            {
                ANSB = (Arg0 & One)
            }

            Method (GWLS, 0, NotSerialized)
            {
                Local0 = ABT1 /* \_SB_.IAOE.ABT1 */
                If (\_SB.PCI0.LPC.EC.GSTS)
                {
                    Local0 |= One
                }

                Local0 &= One
                Local1 = ABT0 /* \_SB_.IAOE.ABT0 */
                Local0 |= (Local1 & 0x02)
                Local0 |= (Local1 & 0x04)
                Local0 |= (Local1 & 0x08)
                Return (Local0)
            }

            Method (SWLS, 1, NotSerialized)
            {
                Local0 = ABT1 /* \_SB_.IAOE.ABT1 */
                Local0 = ((Local0 & 0xFE) | (Arg0 & One))
                ABT1 = Local0
                Local0 = ABT0 /* \_SB_.IAOE.ABT0 */
                Local0 &= 0xF1
                Local0 |= (Arg0 & 0x02)
                ABT0 = Local0
                If ((Local0 & 0x02))
                {
                    \ISCG |= 0x40
                }
                Else
                {
                    \ISCG &= 0xFFFFFFBF
                }
            }

            Method (GWWS, 0, NotSerialized)
            {
                Local0 = ABT1 /* \_SB_.IAOE.ABT1 */
                Local0 = ((Local0 & 0x02) >> One)
                Local1 = ABT0 /* \_SB_.IAOE.ABT0 */
                Local0 |= ((Local1 & 0x10) >> 0x03)
                Local0 |= ((Local1 & 0x20) >> 0x03)
                Local0 |= ((Local1 & 0x40) >> 0x03)
                Return (Local0)
            }

            Method (SWWS, 1, NotSerialized)
            {
                Local0 = ABT1 /* \_SB_.IAOE.ABT1 */
                Local0 = ((Local0 & 0xFD) | ((Arg0 & One) << One
                    ))
                ABT1 = Local0
                Local0 = ABT0 /* \_SB_.IAOE.ABT0 */
                Local0 &= 0x8F
                Local0 |= ((Arg0 & 0x02) << 0x03)
                ABT0 = Local0
                If ((Local0 & 0x02))
                {
                    \ISCG |= 0x80
                }
                Else
                {
                    \ISCG &= 0xFFFFFF7F
                }
            }

            Method (SASD, 1, NotSerialized)
            {
                SLDR = Arg0
                SSMP = 0xAC
            }

            Method (GPWR, 0, NotSerialized)
            {
                WAKR = 0xAC
                SSMP = 0xAC
                If ((WAKR & 0x0A))
                {
                    \SITT (One)
                }

                If ((WAKR & 0x1F))
                {
                    Return (WAKR) /* External reference */
                }
                Else
                {
                    Return (Zero)
                }
            }

            Method (GAWD, 0, NotSerialized)
            {
                Return (AWS1) /* \_SB_.IAOE.AWS1 */
            }

            Method (SAWD, 1, NotSerialized)
            {
                AWS1 = Arg0
            }

            Method (GACT, 0, NotSerialized)
            {
                Return (PTML) /* \_SB_.IAOE.PTML */
            }

            Method (SACT, 1, NotSerialized)
            {
                PTML = Arg0
            }

            Method (GABL, 0, NotSerialized)
            {
                Return (BLBD) /* \_SB_.IAOE.BLBD */
            }

            Method (SABL, 1, NotSerialized)
            {
                BLBD = Arg0
            }

            Method (GAHL, 0, NotSerialized)
            {
                Return (S0HL) /* \_SB_.IAOE.S0HL */
            }

            Method (SAHL, 1, NotSerialized)
            {
                S0HL = Arg0
            }

            Method (GARL, 0, NotSerialized)
            {
                Return (S0RL) /* \_SB_.IAOE.S0RL */
            }

            Method (SARL, 1, NotSerialized)
            {
                S0RL = Arg0
            }

            Method (GPCS, 0, NotSerialized)
            {
                Return (\_SB.LID._LID) /* External reference */
            }

            Method (GSWR, 0, NotSerialized)
            {
                WAKR = 0xAC
                SSMP = 0xAC
                If ((WAKR & 0x1F))
                {
                    Return (WAKR) /* External reference */
                }
                Else
                {
                    Return (Zero)
                }
            }
        }
    }
}

